Feature Request: Wiki ACLs (Access control for individual pages)
Target version:    

Resolution:    

Description

It would be nice if redmine would support ACLs (access control) for individual wiki pages or groups of wiki pages.

Our use-case:

We'd like to give out wiki access to sub-contractors, but only to the parts of the wiki that are their business.

In our case that means a given sub-contractor should see:

The wiki pages relevant to his project

Parts of the global wiki documentation that we deem non-confidential

That sub-contractor should generally not be able to see anything else. In particular not pages that are meant for other

sub-contractors and internal documents that we just don't want them to see.

To achieve this goal we have experimented with creating sub-projects for individual sub-contractors but this approach is very

cumbersome and error-prone. For example we are forced to copy individual pages from our global documentation to the sub-project

wikis to make them available to the contractor - that duplication doesn't scale and is unmaintainable.

To better handle such situations I propose the following implementation (or similar):

Provide a way to tag wiki-pages with ACL-Tokens. This could be achieved with inline code, e.g. a magic line like "#ACL

read,write ContractorRole" somewhere in the page source would grant read/write access to that role. Or redmine could provide

nice GUI elements to achieve the same task.

Provide a per-project toggle to set the wiki pages to "Allow-default" or "Deny-default".

Provide a per-project list of default access patterns. For example in a given project we may like to set all pages whose names

start with "Internal" to be set to "Deny-Default" and "read/write for RoleDevTeam". Such a patterns list would make it easy and

straightforward to divide a wiki into any number of access-zones.

Well, that would be my ideas, I'm sure they can be improved - please discuss.

Related issues:

Related to Redmine - Feature #1086: Fine grained permissions New 2008-04-22

Has duplicate Redmine - Feature #8392: Grant access to particular Wiki page Closed 2011-05-18

History

#1 - 2009-02-03 16:19 - Juris P

+1

#2 - 2009-02-25 18:08 - Anonymous

+1

An simple solution would fit our needs so just internal/public per page would be enough. Where all logged in users can see "internal" pages. Of

course it would even be better to integrate it into the existing Rights system.

#3 - 2009-04-18 17:37 - Sven Schwyn

+1

I second Bernhard: A checkbox to set the page "public" or "private" would be sufficient. However, "private" pages should only be visible if a user is

both logged in and member of the project the wiki is hooked to. Furthermore, wiki links from public to private pages should display an access denied

info.
#4 - 2009-04-25 07:08 - Lorenzo Pisani

+1

#5 - 2009-05-11 10:03 - Michael Wünsch

+1

#6 - 2009-07-10 16:27 - Felipe Reyes

+1

I think that use case proposed by Jimi Jones is the really useful one, moinmoin wiki has that kind of ACL and is very powerful and flexible, probably to

avoid the gui part (that could be complex and hard to build a simple and usable one) in a first stage use the magic first line #ACL.

Is this posible that could be implemented like a plugin?, My knowledge of ruby on rails is zero, but maybe somebody at my work aims to develop a

plugin.

#7 - 2009-10-27 15:20 - Michael Aye

+1

We have meeting minutes that we would like to keep confidential, but lots of other useful stuff on the Wiki, that is interesting for 'external' users.

Please implement!

#8 - 2009-10-27 17:59 - Nicolas Zinopoulos

+1

#9 - 2010-04-21 19:48 - James Downs

How do we go about getting this feature started?

#10 - 2010-09-02 09:45 - Hans Schmidt

+1

#11 - 2010-09-20 11:00 - goldleaf asd

SPAM

#12 - 2010-09-20 12:52 - Yaroslav Matsera

+1

#13 - 2010-10-25 15:17 - arthur me

+1 This would be extremely helpful for having clients interacting with developers on projects while keeping some content separate from them.

#14 - 2010-11-19 20:55 - Rares Pop

+1.

#15 - 2010-12-14 11:09 - Lukas Jelonek

+1

#16 - 2011-01-07 19:17 - Raidel del Peso

+1

Also might be useful to extend this feature to a wiki format tag (like < pre>) that can be inserted anywhere where wiki format is accepted (issues

description, etc) making parts of an issue description private is very useful

even tagging an issue notes as private or "hidden to not registered users"

#17 - 2011-03-22 18:51 - Adriano Carneiro

+1

We only need two different Wiki areas: Public Wiki and Private Wiki. Permissions would be set like today, in the Role edit. Instead of only the Wiki

box that we have there, we'd have Public Wiki and Private Wiki.

#18 - 2011-05-31 09:55 - Matthias Lohr

+1
#19 - 2011-06-01 02:58 - Iwao AVE!

+1

public/private setting is not good enough for our needs because our company uses Redmine to communicate with our clients and there's no public

users (every user has to login).

Setting a minimum role for each wiki page would be sufficient, though.

The role of the client is 'Reporter' and some wiki pages should be visible/editable only to 'Developer' and 'Manager' (i.e. members of our comapny).

#20 - 2011-06-01 03:31 - Iwao AVE!

Please ignore my last comment. I had just started using Redmine and expected there can be multiple wiki pages for a project...

#21 - 2011-10-14 10:24 - Igor Zubkov

+1

#22 - 2011-12-30 07:37 - Naveen Prabhu

+1

#23 - 2012-01-10 09:04 - Mikhail Tcishewsky

+1

#24 - 2012-02-21 07:00 - Kirill Bezrukov (RedmineUP)

+1

#25 - 2012-03-04 19:35 - Oleg Kandaurov

Please, take a look at my plugin http://www.redmine.org/plugins/private_wiki

#26 - 2012-07-13 09:53 - Anton Gillert

+1

Oleg Volossetski Kandaurov, thanks i'll try your plugin

#27 - 2012-09-05 23:18 - Vasa Maximov

+1

I want to be able to give read access for pages only to particular users or roles.

#28 - 2013-02-28 18:25 - Antuan Shakhin

We(Catincan) are interested in financially contributing to this feature if one of the redmine developers is willing to implement it.

Why not crowdfund this feature on https://www.catincan.com ?

#29 - 2014-08-22 07:30 - Hans Ginzel

+1

We (Generali CZ) are also interested.

Is a copy of #1086.

#30 - 2014-09-20 17:35 - Toshi MARUYAMA

- Related to Feature #1086: Fine grained permissions added

#31 - 2015-11-09 18:50 - [ Desperados ]

+1

#32 - 2016-01-30 05:36 - Anh Le Giang

+ 1

#33 - 2016-02-20 10:59 - Toshi MARUYAMA

- Has duplicate Feature #8392: Grant access to particular Wiki page added

#34 - 2016-04-18 10:57 - Cristiano Cesario

+1
#35 - 2016-06-09 14:47 - Michael Schaefer

+1

#36 - 2016-12-19 15:39 - Phil Valentine

+1 Yes please, we have information applicable to fellow 'developers' that it is not desirable to have shared with other project members.

It would be great to be able to specify that the wiki page security is set to:

Public (anyone, signed in or not)

Private (logged in only)

Restricted (Black / White list based on existing 'groups')

#37 - 2017-01-12 11:37 - Salvo Rapisarda

+1

#38 - 2017-05-19 22:07 - Гордеев Алексей

+1.

#39 - 2017-10-05 17:12 - @ go2null

To save people looking, here are two plugins:

1. Manage Wiki View Page permission [https://github.com/stpl/manage_wiki_view_page_permission]

2. Wiki permissions [https://github.com/edtsech/redmine_wiki_permissions] [last updated 2012]

#40 - 2017-11-09 17:58 - cyril Thibout

and only the first one is working with current versions of ruby/redmine :(

#41 - 2017-11-20 12:03 - Maksim Makhniuk

+1 long awaiting feature

#42 - 2018-08-31 20:00 - Kamil .

+1

#43 - 2019-10-23 11:15 - Heiko Robert

+1

unfortunately the plugins mentioned in #2636#note-40 seem to be dead and don't support redmine 4

#44 - 2020-03-27 11:45 - Tuan-Tu Tran

- File 2020-03-27_11h41_12.png added

Heiko Robert wrote:

unfortunately the plugins mentioned in #2636#note-40 seem to be dead and don't support redmine 4

 Did you actually try to use it(them) on redmine 4? Or do you just assume so because of the compatible versions advertised in the plugin page:

https://www.redmine.org/plugins/manage_wiki_view_page_permission
I imagine a scenario where this actually works with Redmine 4 but it's just the plugin maintainer that did not update the advertised supported versions.

I don't know how Redmine plugins publication work but in this scenario, I'm assuming the advertised version are not automatically checked but

manually updated by the plugin maintainer.

Thanks

#45 - 2020-04-01 14:38 - Tuan-Tu Tran

Heiko Robert wrote:

+1

unfortunately the plugins mentioned in #2636#note-40 seem to be dead and don't support redmine 4

 Well actually one of the plugin actually works with Redmine 4.1.0

https://www.redmine.org/plugins/manage_wiki_view_page_permission
